(function(){
	window.$WebApp = window.$WebApp || {};
	$WebApp.Session = {_monitoring:false, _loggedIn:false};
	$WebApp.Session.touch = function(retry) {
		var req = new XMLHttpRequest();
		req.onreadystatechange = function() {
			if(this.readyState == 4) {
				if(this.status == 200) {
					$WebApp.Session._loggedIn = true;
					var time = parseInt(this.responseText);
					console.log("[$WebApp.Session] Session touched: "+time+" ms.");
					if(!$WebApp.Session._monitoring) {
						$WebApp.Session._monitoring = true;
						console.log("[$WebApp.Session] Session monitor started");
						$WebApp.Session.monitor();
					}
				}
				else if(this.status == 401) {
					console.log("[$WebApp.Session] Session is not logged in. No further monitoring actions will be fired.");
				}
				else {
					console.log("[$WebApp.Session] Failed to touch session ("+this.status+"). "+(retry?"Retrying in 10 seconds.":""));
					if(retry)
						setTimeout($WebApp.Session.touch, 10000, retry);
				}
			}
		};
		req.open('GET', /*[[@{/.services/com.assemblycms.core/auth/ttl?$WebApp.Session.touch}]]*/ "", true);
		req.send(null);
	};
	
	$WebApp.Session.monitor = function() {
		var req = new XMLHttpRequest();
		req.onreadystatechange = function() {
			if(this.readyState == 4) {
				var next = 10000; 
				if(this.status == 200) {
					var time = parseInt(this.responseText);
					console.log("[$WebApp.Session] Session expiration: "+time+" ms");
					next = time - 1000*60*2;
					if(next<=0) {
						next = 10000;
						if(next>time)
							next = time;
						var event = new CustomEvent("$WebApp.Session.SESSION_WILL_EXPIRE", {"time": time});
						document.dispatchEvent(event);
					}
				}
				else if(this.status == 401) {
					$WebApp.Session.invalidate();
					return;
				}
				setTimeout($WebApp.Session.monitor, next);
			}
		};
		req.open('GET', /*[[@{/.services/com.assemblycms.core/auth/ttl}]]*/ "", true);
		req.send(null);
	};
	
	$WebApp.Session.invalidate = function() {
		console.log("[$WebApp.Session] Session expired");
		location.reload();
	};
	
	$WebApp.Session.touch(true);
})();